=== modified file 'INSTALL'
--- INSTALL	2014-07-25 22:44:20 +0000
+++ INSTALL	2013-06-23 15:13:06 +0000
@@ -4,15 +4,14 @@
   
 ** Operating System
    
-   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat" (or later).
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
-   and that the initial RAM file system image file is automatically
-   made unreadable.  The server and client programs themselves *could*
-   be run in other distributions, but they *are* specific to GNU/Linux
-   systems, and are not written with portabillity to other Unixes in
-   mind.
+   and that the initrd.img file is automatically made unreadable.  The
+   server and client programs themselves *could* be run in other
+   distributions, but they *are* specific to GNU/Linux systems, and
+   are not written with portabillity to other Unixes in mind.
    
 ** Libraries
    
@@ -28,7 +27,7 @@
     + DocBook 4.5         http://www.docbook.org/
       Note: DocBook 5.0 is not compatible.
     + DocBook XSL stylesheets 1.71.0
-                         http://wiki.docbook.org/DocBookXslStylesheets
+                   http://wiki.docbook.org/topic/DocBookXslStylesheets
     
     Package names:
     docbook docbook-xsl
@@ -38,40 +37,32 @@
     "man -l mandos.8".
     
 *** Mandos Server
-    + GnuTLS 2.4          http://www.gnutls.org/
-      Note: GnuTLS 3 will only work with Python-GnuTLS 2
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.7          https://www.python.org/
-    + Python-GnuTLS 1.1.5 https://pypi.python.org/pypi/python-gnutls/
+    + Python 2.6          http://www.python.org/
+    + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + PyGObject 2.14.2    https://developer.gnome.org/pygobject/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    + Urwid 1.0.1         http://urwid.org/
-      (Only needed by the "mandos-monitor" tool.)
+    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
-    + fping 2.4b2-to-ipv6      http://www.fping.org/
-    + ssh-keyscan from OpenSSH http://www.openssh.com/
+    + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-gobject python-urwid pkg-config fping ssh-client
+    python-gobject python-urwid
     
 *** Mandos Client
     + initramfs-tools 0.85i
-                        https://tracker.debian.org/pkg/initramfs-tools
-    + GnuTLS 2.4        http://www.gnutls.org/
-    + Avahi 0.6.16      http://www.avahi.org/
-    + GnuPG 1.4.9       https://www.gnupg.org/
-    + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    
-    Strongly recommended:
-    + OpenSSH           http://www.openssh.com/
+                  http://packages.qa.debian.org/i/initramfs-tools.html
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
+    + Avahi 0.6.16        http://www.avahi.org/
+    + GnuPG 1.4.9         http://www.gnupg.org/
+    + GPGME 1.1.6         http://www.gnupg.org/related_software/gpgme/
     
     Package names:
     initramfs-tools libgnutls-dev libavahi-core-dev gnupg
-    libgpgme11-dev pkg-config ssh
+    libgpgme11-dev
 
 * Installing the Mandos server
   
@@ -107,11 +98,15 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use any special configuration needed for
-     your local system.  Note: This is not necessary if the server is
-     present on the same wired local network as the client.  If you do
-     make changes to /etc/mandos/plugin-runner.conf, the initrd.img
-     file must be updated, possibly using the following command:
+  4. Configure the client to use the correct network interface.  The
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
@@ -131,14 +126,12 @@
      
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
-     take more than five minutes to reboot.
+     take more than an hour to reboot.
 
 * Further customizations
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used and SSH is not installed, it is suggested that
-  a more cryptographically secure checker program is used and
-  configured, since, without IPsec, ping packets can be faked.
-
-#+STARTUP: showall
+  If IPsec is not used, it is suggested that a more cryptographically
+  secure checker program is used and configured, since without IPsec
+  ping packets can be faked.

=== modified file 'Makefile'
--- Makefile	2014-07-17 03:24:57 +0000
+++ Makefile	2014-05-11 20:18:48 +0000
@@ -26,7 +26,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.7
+version=1.6.5
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -264,18 +264,15 @@
 	@echo "# ignored.  The messages are caused by not running as root, but   #"
 	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
 	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setgid: Operation not permitted             #"
-	@echo "#                     setuid: Operation not permitted             #"
+	@echo "# From plugin-runner: setuid: Operation not permitted             #"
 	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client:                                             #"
-	@echo "#             Failed to raise privileges: Operation not permitted #"
-	@echo "#             Warning: network hook \"*\" exited with status *      #"
+	@echo "# From mandos-client: setuid: Operation not permitted             #"
+	@echo "#                     seteuid: Operation not permitted            #"
+	@echo "#                     klogctl: Operation not permitted            #"
 	@echo "###################################################################"
-# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
-		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
 		$(CLIENTARGS)
 
 # Used by run-client
@@ -296,7 +293,7 @@
 	install --directory confdir
 	install --mode=u=rw $< $@
 # Add a client password
-	./mandos-keygen --dir keydir --password --no-ssh >> $@
+	./mandos-keygen --dir keydir --password >> $@
 statedir:
 	install --directory statedir
 

=== modified file 'NEWS'
--- NEWS	2014-07-17 03:24:57 +0000
+++ NEWS	2014-05-11 20:18:48 +0000
@@ -1,25 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.6.7 (2014-07-17)
-* Client
-** Bug fix: Now compatible with GPGME 1.5.0.
-** Bug fix: Fixed minor memory leaks.
-* Server
-** "mandos-monitor" now has verbose logging, toggleable with "v".
-
-Version 1.6.6 (2014-07-13)
-* Client
-** If client host has an SSH server, "mandos-keygen --password" now
-   outputs "checker" option which uses "ssh-keyscan"; this is more
-   secure than the default "fping" checker.
-** Bug fix: allow "." in network hook names, to match documentation.
-** Better error messages.
-* Server
-** New --no-zeroconf option.
-** Bug fix: Fix --servicename option, broken since 1.6.4.
-** Bug fix: Fix --socket option work for --socket=0.
-
 Version 1.6.5 (2014-05-11)
 * Client
 ** Work around bug in GnuPG <http://bugs.g10code.com/gnupg/issue1622>

=== modified file 'TODO'
--- TODO	2014-07-14 21:41:08 +0000
+++ TODO	2014-06-08 02:31:50 +0000
@@ -44,6 +44,8 @@
 * plugin-runner
 ** TODO handle printing for errors for plugins
 *** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
+** TODO [#B] use scandirat(3) instead of readdir(3)
+*** Must wait until GNU libc 2.15
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
 
@@ -81,11 +83,7 @@
    http://standards.freedesktop.org/secret-service/
 ** TODO Remove D-Bus interfaces with old domain name			  :2:
 ** TODO Remove old string_to_delta format				  :2:
-** TODO http://0pointer.de/blog/projects/stateless.html
-*** tmpfiles snippet to create /var/lib/mandos with right user+perms
-*** File in /usr/lib/sysusers.d to create user+group "_mandos"
-** TODO Error handling on error parsing config files
-** TODO init.d script error handling
+** TODO --no-zeroconf (only valid if port or socket is set)
 
 * mandos.xml
 ** Add mandos contact info in manual pages

=== modified file 'common.ent'
--- common.ent	2014-07-17 03:24:57 +0000
+++ common.ent	2014-05-11 20:18:48 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.7">
+<!ENTITY version "1.6.5">

=== modified file 'debian/changelog'
--- debian/changelog	2014-07-17 03:24:57 +0000
+++ debian/changelog	2014-06-06 02:29:14 +0000
@@ -1,18 +1,3 @@
-mandos (1.6.7-1) unstable; urgency=medium
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 17 Jul 2014 05:22:45 +0200
-
-mandos (1.6.6-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/mandos.postinst: Fix typo in comment.
-  * debian/control (mandos/Recommends): Changed to "ssh-client | fping".
-    (mandos-client/Recommends): New; set to "ssh".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Jul 2014 22:49:21 +0200
-
 mandos (1.6.5-3) unstable; urgency=medium
 
   * debian/control (mandos-client/Depends): Add "dpkg-dev (>=1.16.0)";

=== modified file 'debian/control'
--- debian/control	2014-07-25 22:44:20 +0000
+++ debian/control	2014-05-30 09:53:03 +0000
@@ -7,8 +7,9 @@
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
-	python2.7-dbus, python2.7-avahi, python2.7-gobject
+Build-Depends-Indep: systemd, python (>=2.6), python-gnutls,
+	python-dbus, python-avahi, python-gobject,
+	python (>=2.7) | python-argparse
 Standards-Version: 3.9.5
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
@@ -16,12 +17,11 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (<= 2.7), python2.7, python-gnutls,
-	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
-	python2.7-avahi, python-gobject, python2.7-gobject,
-	avahi-daemon, adduser, python-urwid, python2.7-urwid,
-	gnupg (<< 2), initscripts (>= 2.88dsf-13.3)
-Recommends: ssh-client | fping
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
+	python-avahi, python-gobject, avahi-daemon, adduser,
+	python-urwid, python (>=2.7) | python-argparse, gnupg (<< 2),
+	initscripts (>= 2.88dsf-13.3)
+Recommends: fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
@@ -41,7 +41,6 @@
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2), initramfs-tools, dpkg-dev (>=1.16.0)
-Recommends: ssh
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2014-07-16 23:44:54 +0000
+++ initramfs-tools-hook	2013-10-28 08:38:47 +0000
@@ -150,17 +150,11 @@
 done
 
 # GPGME needs GnuPG
-gpg=/usr/bin/gpg
 libgpgme11_version="`dpkg-query --showformat='${Version}' --show libgpgme11`"
-if dpkg --compare-versions "$libgpgme11_version" ge 1.5.0-0.1; then
-    if [ -e /usr/bin/gpgconf ]; then
-	if [ ! -e "${DESTDIR}/usr/bin/gpgconf" ]; then
-	    copy_exec /usr/bin/gpgconf
-	fi
-	gpg="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg:[^:]*://p'`"
-    fi
-elif dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
+if dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
     gpg=/usr/bin/gpg2
+else
+    gpg=/usr/bin/gpg
 fi
 if [ ! -e "${DESTDIR}$gpg" ]; then
     copy_exec "$gpg"

=== modified file 'intro.xml'
--- intro.xml	2014-06-22 02:19:30 +0000
+++ intro.xml	2011-12-31 23:05:34 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -215,22 +215,17 @@
       </para>
     </refsect2>
     
-    <refsect2 id="fakecheck">
-      <title>Faking checker results?</title>
+    <refsect2 id="fakeping">
+      <title>Faking ping replies?</title>
       <para>
-	If the Mandos client does not have an SSH server, the default
-	is for the Mandos server to use
+	The default for the server is to use
 	<quote><literal>fping</literal></quote>, the replies to which
 	could be faked to eliminate the timeout.  But this could
 	easily be changed to any shell command, with any security
-	measures you like.  If the Mandos client
-	<emphasis>has</emphasis> an SSH server, the default
-	configuration (as generated by
-	<command>mandos-keygen</command> with the
-	<option>--password</option> option) is for the Mandos server
-	to use an <command>ssh-keyscan</command> command with strict
-	keychecking, which can not be faked.  Alternatively, IPsec
-	could be used for the ping packets, making them secure.
+	measures you like.  It could, for instance, be changed to an
+	SSH command with strict keychecking, which could not be faked.
+	Or IPsec could be used for the ping packets, making them
+	secure.
       </para>
     </refsect2>
   </refsect1>

=== modified file 'mandos'
--- mandos	2014-07-25 23:39:49 +0000
+++ mandos	2014-06-08 17:36:33 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python2.7
+#!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 # 
 # Mandos server - give out binary blobs to connecting clients.
@@ -88,7 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.6.7"
+version = "1.6.5"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -338,7 +338,7 @@
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
                             unicode(error))
-            raise AvahiGroupError("State changed: {!s}"
+            raise AvahiGroupError("State changed: {0!s}"
                                   .format(error))
     
     def cleanup(self):
@@ -395,12 +395,19 @@
         """Add the new name to the syslog messages"""
         ret = AvahiService.rename(self)
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
+                               ('Mandos ({0}) [%(process)d]:'
                                 ' %(levelname)s: %(message)s'
                                 .format(self.name)))
         return ret
 
 
+def timedelta_to_milliseconds(td):
+    "Convert a datetime.timedelta() to milliseconds"
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
+
+
 class Client(object):
     """A representation of a client host served by this server.
     
@@ -461,6 +468,21 @@
                         "enabled": "True",
                         }
     
+    def timeout_milliseconds(self):
+        "Return the 'timeout' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.timeout)
+    
+    def extended_timeout_milliseconds(self):
+        "Return the 'extended_timeout' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.extended_timeout)
+    
+    def interval_milliseconds(self):
+        "Return the 'interval' attribute in milliseconds"
+        return timedelta_to_milliseconds(self.interval)
+    
+    def approval_delay_milliseconds(self):
+        return timedelta_to_milliseconds(self.approval_delay)
+    
     @staticmethod
     def config_parser(config):
         """Construct a new dict of client settings of this form:
@@ -491,7 +513,7 @@
                           "rb") as secfile:
                     client["secret"] = secfile.read()
             else:
-                raise TypeError("No secret or secfile for section {}"
+                raise TypeError("No secret or secfile for section {0}"
                                 .format(section))
             client["timeout"] = string_to_delta(section["timeout"])
             client["extended_timeout"] = string_to_delta(
@@ -514,7 +536,7 @@
             server_settings = {}
         self.server_settings = server_settings
         # adding all client settings
-        for setting, value in settings.items():
+        for setting, value in settings.iteritems():
             setattr(self, setting, value)
         
         if self.enabled:
@@ -603,16 +625,14 @@
         if self.checker_initiator_tag is not None:
             gobject.source_remove(self.checker_initiator_tag)
         self.checker_initiator_tag = (gobject.timeout_add
-                                      (int(self.interval
-                                           .total_seconds() * 1000),
+                                      (self.interval_milliseconds(),
                                        self.start_checker))
         # Schedule a disable() when 'timeout' has passed
         if self.disable_initiator_tag is not None:
             gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = (gobject.timeout_add
-                                      (int(self.timeout
-                                           .total_seconds() * 1000),
-                                       self.disable))
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
         # Also start a new checker *right now*.
         self.start_checker()
     
@@ -649,8 +669,8 @@
             self.disable_initiator_tag = None
         if getattr(self, "enabled", False):
             self.disable_initiator_tag = (gobject.timeout_add
-                                          (int(timeout.total_seconds()
-                                               * 1000), self.disable))
+                                          (timedelta_to_milliseconds
+                                           (timeout), self.disable))
             self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
@@ -687,10 +707,10 @@
         # Start a new checker if needed
         if self.checker is None:
             # Escape attributes for the shell
-            escaped_attrs = { attr:
-                                  re.escape(unicode(getattr(self,
-                                                            attr)))
-                              for attr in self.runtime_expansions }
+            escaped_attrs = dict(
+                (attr, re.escape(unicode(getattr(self, attr))))
+                for attr in
+                self.runtime_expansions)
             try:
                 command = self.checker_command % escaped_attrs
             except TypeError as error:
@@ -777,7 +797,7 @@
     # "Set" method, so we fail early here:
     if byte_arrays and signature != "ay":
         raise ValueError("Byte arrays not supported for non-'ay'"
-                         " signature {!r}".format(signature))
+                         " signature {0!r}".format(signature))
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
@@ -862,7 +882,7 @@
         If called like _is_dbus_thing("method") it returns a function
         suitable for use as predicate to inspect.getmembers().
         """
-        return lambda obj: getattr(obj, "_dbus_is_{}".format(thing),
+        return lambda obj: getattr(obj, "_dbus_is_{0}".format(thing),
                                    False)
     
     def _get_all_dbus_things(self, thing):
@@ -918,7 +938,7 @@
             # signatures other than "ay".
             if prop._dbus_signature != "ay":
                 raise ValueError("Byte arrays not supported for non-"
-                                 "'ay' signature {!r}"
+                                 "'ay' signature {0!r}"
                                  .format(prop._dbus_signature))
             value = dbus.ByteArray(b''.join(chr(byte)
                                             for byte in value))
@@ -989,7 +1009,7 @@
                                               (prop,
                                                "_dbus_annotations",
                                                {}))
-                        for name, value in annots.items():
+                        for name, value in annots.iteritems():
                             ann_tag = document.createElement(
                                 "annotation")
                             ann_tag.setAttribute("name", name)
@@ -998,11 +1018,11 @@
                 # Add interface annotation tags
                 for annotation, value in dict(
                     itertools.chain.from_iterable(
-                        annotations().items()
+                        annotations().iteritems()
                         for name, annotations in
                         self._get_all_dbus_things("interface")
                         if name == if_tag.getAttribute("name")
-                        )).items():
+                        )).iteritems():
                     ann_tag = document.createElement("annotation")
                     ann_tag.setAttribute("name", annotation)
                     ann_tag.setAttribute("value", value)
@@ -1064,7 +1084,7 @@
     """
     def wrapper(cls):
         for orig_interface_name, alt_interface_name in (
-            alt_interface_names.items()):
+            alt_interface_names.iteritems()):
             attr = {}
             interface_names = set()
             # Go though all attributes of the class
@@ -1187,7 +1207,7 @@
                                         attribute.func_closure)))
             if deprecate:
                 # Deprecate all alternate interfaces
-                iname="_AlternateDBusNames_interface_annotation{}"
+                iname="_AlternateDBusNames_interface_annotation{0}"
                 for interface_name in interface_names:
                     @dbus_interface_annotations(interface_name)
                     def func(self):
@@ -1202,7 +1222,7 @@
             if interface_names:
                 # Replace the class with a new subclass of it with
                 # methods, signals, etc. as created above.
-                cls = type(b"{}Alternate".format(cls.__name__),
+                cls = type(b"{0}Alternate".format(cls.__name__),
                            (cls,), attr)
         return cls
     return wrapper
@@ -1249,7 +1269,7 @@
                    to the D-Bus.  Default: no transform
         variant_level: D-Bus variant level.  Default: 1
         """
-        attrname = "_{}".format(dbus_name)
+        attrname = "_{0}".format(dbus_name)
         def setter(self, value):
             if hasattr(self, "dbus_object_path"):
                 if (not hasattr(self, attrname) or
@@ -1285,23 +1305,21 @@
     approval_delay = notifychangeproperty(dbus.UInt64,
                                           "ApprovalDelay",
                                           type_func =
-                                          lambda td: td.total_seconds()
-                                          * 1000)
+                                          timedelta_to_milliseconds)
     approval_duration = notifychangeproperty(
         dbus.UInt64, "ApprovalDuration",
-        type_func = lambda td: td.total_seconds() * 1000)
+        type_func = timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt64, "Timeout",
-                                   type_func = lambda td:
-                                       td.total_seconds() * 1000)
+                                   type_func =
+                                   timedelta_to_milliseconds)
     extended_timeout = notifychangeproperty(
         dbus.UInt64, "ExtendedTimeout",
-        type_func = lambda td: td.total_seconds() * 1000)
+        type_func = timedelta_to_milliseconds)
     interval = notifychangeproperty(dbus.UInt64,
                                     "Interval",
                                     type_func =
-                                    lambda td: td.total_seconds()
-                                    * 1000)
+                                    timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -1350,8 +1368,9 @@
     
     def approve(self, value=True):
         self.approved = value
-        gobject.timeout_add(int(self.approval_duration.total_seconds()
-                                * 1000), self._reset_approved)
+        gobject.timeout_add(timedelta_to_milliseconds
+                            (self.approval_duration),
+                            self._reset_approved)
         self.send_changedstate()
     
     ## D-Bus methods, signals & properties
@@ -1460,8 +1479,7 @@
                            access="readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_delay.total_seconds()
-                               * 1000)
+            return dbus.UInt64(self.approval_delay_milliseconds())
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
     
     # ApprovalDuration - property
@@ -1469,8 +1487,8 @@
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_duration.total_seconds()
-                               * 1000)
+            return dbus.UInt64(timedelta_to_milliseconds(
+                    self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
     # Name - property
@@ -1542,7 +1560,7 @@
                            access="readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.timeout.total_seconds() * 1000)
+            return dbus.UInt64(self.timeout_milliseconds())
         old_timeout = self.timeout
         self.timeout = datetime.timedelta(0, 0, 0, value)
         # Reschedule disabling
@@ -1559,16 +1577,15 @@
                 gobject.source_remove(self.disable_initiator_tag)
                 self.disable_initiator_tag = (
                     gobject.timeout_add(
-                        int((self.expires - now).total_seconds()
-                            * 1000), self.disable))
+                        timedelta_to_milliseconds(self.expires - now),
+                        self.disable))
     
     # ExtendedTimeout - property
     @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def ExtendedTimeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.extended_timeout.total_seconds()
-                               * 1000)
+            return dbus.UInt64(self.extended_timeout_milliseconds())
         self.extended_timeout = datetime.timedelta(0, 0, 0, value)
     
     # Interval - property
@@ -1576,7 +1593,7 @@
                            access="readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.interval.total_seconds() * 1000)
+            return dbus.UInt64(self.interval_milliseconds())
         self.interval = datetime.timedelta(0, 0, 0, value)
         if getattr(self, "checker_initiator_tag", None) is None:
             return
@@ -1742,8 +1759,8 @@
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.NeedApproval(
-                                client.approval_delay.total_seconds()
-                                * 1000, client.approved_by_default)
+                                client.approval_delay_milliseconds(),
+                                client.approved_by_default)
                     else:
                         logger.warning("Client %s was not approved",
                                        client.name)
@@ -1755,7 +1772,9 @@
                     #wait until timeout or approved
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(delay.total_seconds())
+                    client.changedstate.wait(
+                        float(timedelta_to_milliseconds(delay)
+                              / 1000))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -2169,11 +2188,11 @@
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
-                                      token_week)))
+                                      token_week))),
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset(token_duration,) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -2239,7 +2258,7 @@
             elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError("Unknown suffix {!r}"
+                raise ValueError("Unknown suffix {0!r}"
                                  .format(suffix))
         except IndexError as e:
             raise ValueError(*(e.args))
@@ -2262,7 +2281,8 @@
         # Close all standard open file descriptors
         null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
-            raise OSError(errno.ENODEV, "{} not a character device"
+            raise OSError(errno.ENODEV,
+                          "{0} not a character device"
                           .format(os.devnull))
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
@@ -2278,7 +2298,7 @@
     
     parser = argparse.ArgumentParser()
     parser.add_argument("-v", "--version", action="version",
-                        version = "%(prog)s {}".format(version),
+                        version = "%(prog)s {0}".format(version),
                         help="show version number and exit")
     parser.add_argument("-i", "--interface", metavar="IF",
                         help="Bind to interface IF")
@@ -2317,9 +2337,6 @@
                         help="Directory to save/restore state in")
     parser.add_argument("--foreground", action="store_true",
                         help="Run in foreground", default=None)
-    parser.add_argument("--no-zeroconf", action="store_false",
-                        dest="zeroconf", help="Do not use Zeroconf",
-                        default=None)
     
     options = parser.parse_args()
     
@@ -2343,7 +2360,6 @@
                         "socket": "",
                         "statedir": "/var/lib/mandos",
                         "foreground": "False",
-                        "zeroconf": "True",
                         }
     
     # Parse config file for server-global settings
@@ -2376,7 +2392,7 @@
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
                    "use_dbus", "use_ipv6", "debuglevel", "restore",
-                   "statedir", "socket", "foreground", "zeroconf"):
+                   "statedir", "socket", "foreground"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2387,7 +2403,7 @@
             server_settings[option] = unicode(server_settings[option])
     # Force all boolean options to be boolean
     for option in ("debug", "use_dbus", "use_ipv6", "restore",
-                   "foreground", "zeroconf"):
+                   "foreground"):
         server_settings[option] = bool(server_settings[option])
     # Debug implies foreground
     if server_settings["debug"]:
@@ -2396,12 +2412,6 @@
     
     ##################################################################
     
-    if (not server_settings["zeroconf"] and
-        not (server_settings["port"]
-             or server_settings["socket"] != "")):
-            parser.error("Needs port or socket to work without"
-                         " Zeroconf")
-    
     # For convenience
     debug = server_settings["debug"]
     debuglevel = server_settings["debuglevel"]
@@ -2410,7 +2420,6 @@
     stored_state_path = os.path.join(server_settings["statedir"],
                                      stored_state_file)
     foreground = server_settings["foreground"]
-    zeroconf = server_settings["zeroconf"]
     
     if debug:
         initlogger(debug, logging.DEBUG)
@@ -2423,7 +2432,7 @@
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
-                               ('Mandos ({}) [%(process)d]:'
+                               ('Mandos ({0}) [%(process)d]:'
                                 ' %(levelname)s: %(message)s'
                                 .format(server_settings
                                         ["servicename"])))
@@ -2437,9 +2446,6 @@
     global mandos_dbus_service
     mandos_dbus_service = None
     
-    socketfd = None
-    if server_settings["socket"] != "":
-        socketfd = server_settings["socket"]
     tcp_server = MandosServer((server_settings["address"],
                                server_settings["port"]),
                               ClientHandler,
@@ -2449,7 +2455,8 @@
                               gnutls_priority=
                               server_settings["priority"],
                               use_dbus=use_dbus,
-                              socketfd=socketfd)
+                              socketfd=(server_settings["socket"]
+                                        or None))
     if not foreground:
         pidfilename = "/run/mandos.pid"
         if not os.path.isdir("/run/."):
@@ -2525,15 +2532,14 @@
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
-    if zeroconf:
-        protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-        service = AvahiServiceToSyslog(name =
-                                       server_settings["servicename"],
-                                       servicetype = "_mandos._tcp",
-                                       protocol = protocol, bus = bus)
-        if server_settings["interface"]:
-            service.interface = (if_nametoindex
-                                 (str(server_settings["interface"])))
+    protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
+    service = AvahiServiceToSyslog(name =
+                                   server_settings["servicename"],
+                                   servicetype = "_mandos._tcp",
+                                   protocol = protocol, bus = bus)
+    if server_settings["interface"]:
+        service.interface = (if_nametoindex
+                             (str(server_settings["interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2563,7 +2569,7 @@
             os.remove(stored_state_path)
         except IOError as e:
             if e.errno == errno.ENOENT:
-                logger.warning("Could not load persistent state: {}"
+                logger.warning("Could not load persistent state: {0}"
                                 .format(os.strerror(e.errno)))
             else:
                 logger.critical("Could not load persistent state:",
@@ -2574,7 +2580,7 @@
                            "EOFError:", exc_info=e)
     
     with PGPEngine() as pgp:
-        for client_name, client in clients_data.items():
+        for client_name, client in clients_data.iteritems():
             # Skip removed clients
             if client_name not in client_settings:
                 continue
@@ -2605,14 +2611,14 @@
                 if datetime.datetime.utcnow() >= client["expires"]:
                     if not client["last_checked_ok"]:
                         logger.warning(
-                            "disabling client {} - Client never "
+                            "disabling client {0} - Client never "
                             "performed a successful checker"
                             .format(client_name))
                         client["enabled"] = False
                     elif client["last_checker_status"] != 0:
                         logger.warning(
-                            "disabling client {} - Client last"
-                            " checker failed with error code {}"
+                            "disabling client {0} - Client "
+                            "last checker failed with error code {1}"
                             .format(client_name,
                                     client["last_checker_status"]))
                         client["enabled"] = False
@@ -2621,7 +2627,7 @@
                                              .utcnow()
                                              + client["timeout"])
                         logger.debug("Last checker succeeded,"
-                                     " keeping {} enabled"
+                                     " keeping {0} enabled"
                                      .format(client_name))
             try:
                 client["secret"] = (
@@ -2630,7 +2636,7 @@
                                 ["secret"]))
             except PGPError:
                 # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {} old secret"
+                logger.debug("Failed to decrypt {0} old secret"
                              .format(client_name))
                 client["secret"] = (
                     client_settings[client_name]["secret"])
@@ -2644,7 +2650,7 @@
         clients_data[client_name] = client_settings[client_name]
     
     # Create all client objects
-    for client_name, client in clients_data.items():
+    for client_name, client in clients_data.iteritems():
         tcp_server.clients[client_name] = client_class(
             name = client_name, settings = client,
             server_settings = server_settings)
@@ -2733,8 +2739,7 @@
     
     def cleanup():
         "Cleanup function; run on exit"
-        if zeroconf:
-            service.cleanup()
+        service.cleanup()
         
         multiprocessing.active_children()
         wnull.close()
@@ -2754,8 +2759,8 @@
                 
                 # A list of attributes that can not be pickled
                 # + secret.
-                exclude = { "bus", "changedstate", "secret",
-                            "checker", "server_settings" }
+                exclude = set(("bus", "changedstate", "secret",
+                               "checker", "server_settings"))
                 for name, typ in (inspect.getmembers
                                   (dbus.service.Object)):
                     exclude.add(name)
@@ -2784,7 +2789,7 @@
                 except NameError:
                     pass
             if e.errno in (errno.ENOENT, errno.EACCES, errno.EEXIST):
-                logger.warning("Could not save persistent state: {}"
+                logger.warning("Could not save persistent state: {0}"
                                .format(os.strerror(e.errno)))
             else:
                 logger.warning("Could not save persistent state:",
@@ -2819,8 +2824,7 @@
     tcp_server.server_activate()
     
     # Find out what port we got
-    if zeroconf:
-        service.port = tcp_server.socket.getsockname()[1]
+    service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
         logger.info("Now listening on address %r, port %d,"
                     " flowinfo %d, scope_id %d",
@@ -2832,15 +2836,14 @@
     #service.interface = tcp_server.socket.getsockname()[3]
     
     try:
-        if zeroconf:
-            # From the Avahi example code
-            try:
-                service.activate()
-            except dbus.exceptions.DBusException as error:
-                logger.critical("D-Bus Exception", exc_info=error)
-                cleanup()
-                sys.exit(1)
-            # End of Avahi example code
+        # From the Avahi example code
+        try:
+            service.activate()
+        except dbus.exceptions.DBusException as error:
+            logger.critical("D-Bus Exception", exc_info=error)
+            cleanup()
+            sys.exit(1)
+        # End of Avahi example code
         
         gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
                              lambda *args, **kwargs:

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2014-06-22 02:19:30 +0000
+++ mandos-clients.conf.xml	2013-10-20 15:25:09 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2013-10-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -177,13 +177,7 @@
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
 	    ><command>fping</command> <option>-q</option> <option
-	    >--</option> %%(host)s</literal></quote>.  Note that
-	    <command>mandos-keygen</command>, when generating output
-	    to be inserted into this file, normally looks for an SSH
-	    server on the Mandos client, and, if it find one, outputs
-	    a <option>checker</option> option to check for the
-	    client’s key fingerprint – this is more secure against
-	    spoofing.
+	    >--</option> %%(host)s</literal></quote>.
 	  </para>
 	  <para>
 	    In addition to normal start time expansion, this option

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-07-25 23:42:53 +0000
+++ mandos-ctl	2014-05-11 20:18:48 +0000
@@ -26,10 +26,7 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-try:
-    from future_builtins import *
-except ImportError:
-    pass
+from future_builtins import *
 
 import sys
 import argparse
@@ -42,9 +39,6 @@
 
 import dbus
 
-if sys.version_info.major == 2:
-    str = unicode
-
 locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
@@ -72,12 +66,18 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.7"
+version = "1.6.5"
+
+def timedelta_to_milliseconds(td):
+    """Convert a datetime.timedelta object to milliseconds"""
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
     return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
-            .format(days = "{}T".format(td.days) if td.days else "",
+            .format(days = "{0}T".format(td.days) if td.days else "",
                     hours = td.seconds // 3600,
                     minutes = (td.seconds % 3600) // 60,
                     seconds = td.seconds % 60,
@@ -151,11 +151,11 @@
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
-                                      token_week)))
+                                      token_week))),
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset(token_duration,) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -230,7 +230,7 @@
         if keyword in ("Timeout", "Interval", "ApprovalDelay",
                        "ApprovalDuration", "ExtendedTimeout"):
             return milliseconds_to_string(value)
-        return str(value)
+        return unicode(value)
     
     # Create format string to print table rows
     format_string = " ".join("{{{key}:{width}}}".format(
@@ -243,10 +243,10 @@
     # Print header line
     print(format_string.format(**tablewords))
     for client in clients:
-        print(format_string.format(**{ key:
+        print(format_string.format(**dict((key,
                                            valuetostring(client[key],
-                                                         key)
-                                       for key in keywords }))
+                                                         key))
+                                          for key in keywords)))
 
 def has_actions(options):
     return any((options.enable,
@@ -271,7 +271,7 @@
 def main():
     parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
-                        version = "%(prog)s {}".format(version),
+                        version = "%(prog)s {0}".format(version),
                         help="show version number and exit")
     parser.add_argument("-a", "--all", action="store_true",
                         help="Select all clients")
@@ -310,8 +310,7 @@
     parser.add_argument("--approval-duration",
                         help="Set duration of one client approval")
     parser.add_argument("-H", "--host", help="Set host for client")
-    parser.add_argument("-s", "--secret",
-                        type=argparse.FileType(mode="rb"),
+    parser.add_argument("-s", "--secret", type=file,
                         help="Set password blob (file) for client")
     parser.add_argument("-A", "--approve", action="store_true",
                         help="Approve any current client request")
@@ -366,17 +365,18 @@
     clients={}
     
     if options.all or not options.client:
-        clients = { bus.get_object(busname, path): properties
-                    for path, properties in mandos_clients.items() }
+        clients = dict((bus.get_object(busname, path), properties)
+                       for path, properties in
+                       mandos_clients.iteritems())
     else:
         for name in options.client:
-            for path, client in mandos_clients.items():
+            for path, client in mandos_clients.iteritems():
                 if client["Name"] == name:
                     client_objc = bus.get_object(busname, path)
                     clients[client_objc] = client
                     break
             else:
-                print("Client not found on server: {!r}"
+                print("Client not found on server: {0!r}"
                       .format(name), file=sys.stderr)
                 sys.exit(1)
     
@@ -405,8 +405,8 @@
                 """Set a Client D-Bus property, converted
                 from a string to milliseconds."""
                 set_client_prop(prop,
-                                string_to_delta(value).total_seconds()
-                                * 1000)
+                                timedelta_to_milliseconds
+                                (string_to_delta(value)))
             if options.remove:
                 mandos_serv.RemoveClient(client.__dbus_object_path__)
             if options.enable:

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-07-17 03:24:57 +0000
+++ mandos-keygen	2014-05-11 20:18:48 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.7"
+VERSION="1.6.5"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA
@@ -33,7 +33,6 @@
 KEYCOMMENT=""
 KEYEXPIRE=0
 FORCE=no
-SSH=yes
 KEYCOMMENT_ORIG="$KEYCOMMENT"
 mode=keygen
 
@@ -42,8 +41,8 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:fS \
-    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force,no-ssh \
+TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:f \
+    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
     --name "$0" -- "$@"`
 
 help(){
@@ -86,7 +85,6 @@
                         Encrypt a password from FILE using the key in
                         the key directory.  All options other than
                         --dir and --name are ignored.
-  -S, --no-ssh          Don't get SSH key or set "checker" option.
 EOF
 }
 
@@ -105,7 +103,6 @@
 	-c|--comment) KEYCOMMENT="$2"; shift 2;;
 	-x|--expire) KEYEXPIRE="$2"; shift 2;;
 	-f|--force) FORCE=yes; shift;;
-	-S|--no-ssh) SSH=no; shift;;
 	-v|--version) echo "$0 $VERSION"; exit;;
 	-h|--help) help; exit;;
 	--) shift; break;;
@@ -191,7 +188,7 @@
 trap "
 set +e; \
 test -n \"$SECFILE\" && shred --remove \"$SECFILE\"; \
-shred --remove \"$RINGDIR\"/sec* 2>/dev/null;
+shred --remove \"$RINGDIR\"/sec*;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
 tty --quiet && stty echo; \
@@ -277,23 +274,6 @@
 fi
 
 if [ "$mode" = password ]; then
-    
-    # Make SSH be 0 or 1
-    case "$SSH" in
-	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]) SSH=1;;
-	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|*) SSH=0;;
-    esac
-    
-    if [ $SSH -eq 1 ]; then
-	set +e
-	ssh_fingerprint="`ssh-keyscan localhost 2>/dev/null`"
-	if [ $? -ne 0 ]; then
-	    ssh_fingerprint=""
-	fi
-	set -e
-	ssh_fingerprint="${ssh_fingerprint#localhost }"
-    fi
-    
     # Import key into temporary key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor \
@@ -362,10 +342,6 @@
 		/^[^-]/s/^/    /p
 	    }
 	}' < "$SECFILE"
-    if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp="%%(host)s %(ssh_fingerprint)s"'
-	echo "ssh_fingerprint = ${ssh_fingerprint}"
-    fi
 fi
 
 trap - EXIT
@@ -376,5 +352,5 @@
     shred --remove "$SECFILE"
 fi
 # Remove the key rings
-shred --remove "$RINGDIR"/sec* 2>/dev/null
+shred --remove "$RINGDIR"/sec*
 rm --recursive --force "$RINGDIR"

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2014-06-22 02:19:30 +0000
+++ mandos-keygen.xml	2013-10-22 19:24:01 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2013-10-22">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -119,10 +119,7 @@
 	<replaceable>TIME</replaceable></option></arg>
       </group>
       <sbr/>
-      <group>
-	<arg choice="plain"><option>--force</option></arg>
-	<arg choice="plain"><option>-f</option></arg>
-      </group>
+      <arg><option>--force</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -148,10 +145,6 @@
 	<arg choice="plain"><option>-n
 	<replaceable>NAME</replaceable></option></arg>
       </group>
-      <group>
-	<arg choice="plain"><option>--no-ssh</option></arg>
-	<arg choice="plain"><option>-S</option></arg>
-      </group>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -353,22 +346,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      <varlistentry>
-	<term><option>--no-ssh</option></term>
-	<term><option>-S</option></term>
-	<listitem>
-	  <para>
-	    When <option>--password</option> or
-	    <option>--passfile</option> is given, this option will
-	    prevent <command>&COMMANDNAME;</command> from calling
-	    <command>ssh-keyscan</command> to get an SSH fingerprint
-	    for this host and, if successful, output suitable config
-	    options to use this fingerprint as a
-	    <option>checker</option> option in the output.  This is
-	    otherwise the default behavior.
-	  </para>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -525,9 +502,7 @@
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>,
-      <citerefentry><refentrytitle>ssh-keyscan</refentrytitle>
-      <manvolnum>1</manvolnum></citerefentry>
+      <manvolnum>8mandos</manvolnum></citerefentry>
     </para>
   </refsect1>
   

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-07-25 23:42:53 +0000
+++ mandos-monitor	2014-05-11 20:18:48 +0000
@@ -48,7 +48,7 @@
 
 import locale
 
-if sys.version_info.major == 2:
+if sys.version_info[0] == 2:
     str = unicode
 
 locale.setlocale(locale.LC_ALL, '')
@@ -60,7 +60,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.7"
+version = "1.6.5"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -161,8 +161,8 @@
                                          self.rejected,
                                          client_interface,
                                          byte_arrays=True))
-        self.logger('Created client {}'
-                    .format(self.properties["Name"]), level=0)
+        #self.logger('Created client {0}'
+        #            .format(self.properties["Name"]))
     
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
@@ -179,52 +179,51 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            self.logger('Checker for client {} (command "{}")'
-                        ' succeeded'.format(self.properties["Name"],
-                                            command), level=0)
             self.update()
             return
         # Checker failed
         if os.WIFEXITED(condition):
-            self.logger('Checker for client {} (command "{}") failed'
-                        ' with exit code {}'
+            self.logger('Checker for client {0} (command "{1}")'
+                        ' failed with exit code {2}'
                         .format(self.properties["Name"], command,
                                 os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger('Checker for client {} (command "{}") was'
-                        ' killed by signal {}'
+            self.logger('Checker for client {0} (command "{1}") was'
+                        ' killed by signal {2}'
                         .format(self.properties["Name"], command,
                                 os.WTERMSIG(condition)))
         elif os.WCOREDUMP(condition):
-            self.logger('Checker for client {} (command "{}") dumped'
-                        ' core'.format(self.properties["Name"],
-                                       command))
+            self.logger('Checker for client {0} (command "{1}")'
+                        ' dumped core'
+                        .format(self.properties["Name"], command))
         else:
-            self.logger('Checker for client {} completed'
+            self.logger('Checker for client {0} completed'
                         ' mysteriously'
                         .format(self.properties["Name"]))
         self.update()
     
     def checker_started(self, command):
-        """Server signals that a checker started."""
-        self.logger('Client {} started checker "{}"'
-                    .format(self.properties["Name"],
-                            command), level=0)
+        """Server signals that a checker started. This could be useful
+           to log in the future. """
+        #self.logger('Client {0} started checker "{1}"'
+        #            .format(self.properties["Name"],
+        #                    str(command)))
+        pass
     
     def got_secret(self):
-        self.logger('Client {} received its secret'
+        self.logger('Client {0} received its secret'
                     .format(self.properties["Name"]))
     
     def need_approval(self, timeout, default):
         if not default:
-            message = 'Client {} needs approval within {} seconds'
+            message = 'Client {0} needs approval within {1} seconds'
         else:
-            message = 'Client {} will get its secret in {} seconds'
+            message = 'Client {0} will get its secret in {1} seconds'
         self.logger(message.format(self.properties["Name"],
                                    timeout/1000))
     
     def rejected(self, reason):
-        self.logger('Client {} was rejected; reason: {}'
+        self.logger('Client {0} was rejected; reason: {1}'
                     .format(self.properties["Name"], reason))
     
     def selectable(self):
@@ -274,9 +273,9 @@
             else:
                 timer = datetime.timedelta()
             if self.properties["ApprovedByDefault"]:
-                message = "Approval in {}. (d)eny?"
+                message = "Approval in {0}. (d)eny?"
             else:
-                message = "Denial in {}. (a)pprove?"
+                message = "Denial in {0}. (a)pprove?"
             message = message.format(str(timer).rsplit(".", 1)[0])
             self.using_timer(True)
         elif self.properties["LastCheckerStatus"] != 0:
@@ -290,13 +289,13 @@
                 timer = max(expires - datetime.datetime.utcnow(),
                             datetime.timedelta())
             message = ('A checker has failed! Time until client'
-                       ' gets disabled: {}'
+                       ' gets disabled: {0}'
                        .format(str(timer).rsplit(".", 1)[0]))
             self.using_timer(True)
         else:
             message = "enabled"
             self.using_timer(False)
-        self._text = "{}{}".format(base, message)
+        self._text = "{0}{1}".format(base, message)
         
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
@@ -404,7 +403,7 @@
     """This is the entire user interface - the whole screen
     with boxes, lists of client widgets, etc.
     """
-    def __init__(self, max_log_length=1000, log_level=1):
+    def __init__(self, max_log_length=1000):
         DBusGMainLoop(set_as_default=True)
         
         self.screen = urwid.curses_display.Screen()
@@ -448,8 +447,6 @@
         self.log = []
         self.max_log_length = max_log_length
         
-        self.log_level = log_level
-        
         # We keep a reference to the log widget so we can remove it
         # from the ListWalker without it getting destroyed
         self.logbox = ConstrainedListBox(self.log)
@@ -469,8 +466,8 @@
         self.main_loop = gobject.MainLoop()
     
     def client_not_found(self, fingerprint, address):
-        self.log_message("Client with address {} and fingerprint {}"
-                         " could not be found"
+        self.log_message("Client with address {0} and fingerprint"
+                         " {1} could not be found"
                          .format(address, fingerprint))
     
     def rebuild(self):
@@ -489,18 +486,13 @@
             self.uilist.append(self.logbox)
         self.topwidget = urwid.Pile(self.uilist)
     
-    def log_message(self, message, level=1):
+    def log_message(self, message):
         """Log message formatted with timestamp"""
-        if level < self.log_level:
-            return
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw("{}: {}".format(timestamp, message),
-                             level=level)
+        self.log_message_raw(timestamp + ": " + message)
     
-    def log_message_raw(self, markup, level=1):
+    def log_message_raw(self, markup):
         """Add a log message to the log buffer."""
-        if level < self.log_level:
-            return
         self.log.append(urwid.Text(markup, wrap=self.log_wrap))
         if (self.max_log_length
             and len(self.log) > self.max_log_length):
@@ -513,8 +505,8 @@
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        self.log_message("Log visibility changed to: {}"
-                         .format(self.log_visible), level=0)
+        #self.log_message("Log visibility changed to: "
+        #                 + str(self.log_visible))
     
     def change_log_display(self):
         """Change type of log display.
@@ -525,8 +517,7 @@
             self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        self.log_message("Wrap mode: {}".format(self.log_wrap),
-                         level=0)
+        #self.log_message("Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
         """Find a client by its object path and remove it.
@@ -537,7 +528,7 @@
             client = self.clients_dict[path]
         except KeyError:
             # not found?
-            self.log_message("Unknown client {!r} ({!r}) removed"
+            self.log_message("Unknown client {0!r} ({1!r}) removed"
                              .format(name, path))
             return
         client.delete()
@@ -661,8 +652,7 @@
             elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == "ctrl l":
-                self.screen.clear()
+            elif key == "\f":  # Ctrl-L
                 self.refresh()
             elif key == "l" or key == "D":
                 self.toggle_log_display()
@@ -680,9 +670,7 @@
                                             "?: Help",
                                             "l: Log window toggle",
                                             "TAB: Switch window",
-                                            "w: Wrap (log lines)",
-                                            "v: Toggle verbose log",
-                                            ))))
+                                            "w: Wrap (log)"))))
                 self.log_message_raw(("bold",
                                       "  "
                                       .join(("Clients:",
@@ -701,13 +689,6 @@
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            elif key == "v":
-                if self.log_level == 0:
-                    self.log_level = 1
-                    self.log_message("Verbose mode: Off")
-                else:
-                    self.log_level = 0
-                    self.log_message("Verbose mode: On")
             #elif (key == "end" or key == "meta >" or key == "G"
             #      or key == ">"):
             #    pass            # xxx end-of-buffer

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2014-07-14 21:41:08 +0000
+++ mandos-monitor.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2014-07-14">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -129,10 +129,6 @@
 	<entry>Toggle log window line wrap</entry>
       </row>
       <row>
-	<entry>v</entry>
-	<entry>Toggle verbose logging</entry>
-      </row>
-      <row>
 	<entry>Up, Ctrl-P, k</entry>
 	<entry>Move up a line</entry>
       </row>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2014-06-15 02:48:49 +0000
+++ mandos-options.xml	2013-10-24 20:21:45 +0000
@@ -123,11 +123,4 @@
     implies this option.
   </para>
   
-  <para id="zeroconf">
-    This option controls whether the server will announce its
-    existence using Zeroconf.  Default is to use Zeroconf.  If
-    Zeroconf is not used, a <option>port</option> number or a
-    <option>socket</option> is required.
-  </para>
-  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2014-06-15 02:48:49 +0000
+++ mandos.conf	2013-10-22 19:24:01 +0000
@@ -45,9 +45,3 @@
 
 # Whether to run in the foreground
 ;foreground = False
-
-# File descriptor number to use for network socket
-;socket = 
-
-# Whether to use ZeroConf; if false, requires port or socket
-;zeroconf = True

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-07-17 03:24:57 +0000
+++ mandos.lsm	2014-05-11 20:18:48 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.7
-Entered-date:	2014-07-17
+Version:	1.6.5
+Entered-date:	2014-05-11
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -11,13 +11,13 @@
 		belorn@recompile.se (Björn Påhlsson)
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
-Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.7.orig.tar.gz
-Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.7.orig.tar.gz
+Primary-site: http://www.recompile.se/mandos
+	      159K mandos_1.6.5.orig.tar.gz
+Alternate-site: ftp://ftp.recompile.se/pub/mandos
+		159K mandos_1.6.5.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other
-		distributions, but not other Unixes.
-Copying-policy:	GNU General Public License version 3.0 or later
+		distributions, but not other Unixes. 
+Copying-policy: GNU General Public License version 3.0 or later
 End

=== modified file 'mandos.xml'
--- mandos.xml	2014-06-15 02:48:49 +0000
+++ mandos.xml	2013-10-26 19:05:21 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2014-06-15">
+<!ENTITY TIMESTAMP "2013-10-26">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -106,8 +106,6 @@
       <replaceable>FD</replaceable></option></arg>
       <sbr/>
       <arg><option>--foreground</option></arg>
-      <sbr/>
-      <arg><option>--no-zeroconf</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -325,13 +323,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>--no-zeroconf</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="zeroconf"/>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2014-07-16 01:41:23 +0000
+++ plugin-runner.c	2014-06-14 22:55:11 +0000
@@ -349,7 +349,7 @@
   char *plugindir = NULL;
   char *argfile = NULL;
   FILE *conffp;
-  struct dirent **direntries = NULL;
+  struct dirent **direntries;
   struct stat st;
   fd_set rfds_all;
   int ret, maxfd = 0;
@@ -829,6 +829,7 @@
     ret = set_cloexec_flag(dir_fd);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(dir_fd));
       exitstatus = EX_OSERR;
       goto fallback;
     }
@@ -874,7 +875,7 @@
 #endif	/* not __GLIBC__ */
   if(numplugins == -1){
     error(0, errno, "Could not scan plugin dir");
-    direntries = NULL;
+    TEMP_FAILURE_RETRY(close(dir_fd));
     exitstatus = EX_OSERR;
     goto fallback;
   }
@@ -887,14 +888,12 @@
     int plugin_fd = openat(dir_fd, direntries[i]->d_name, O_RDONLY);
     if(plugin_fd == -1){
       error(0, errno, "Could not open plugin");
-      free(direntries[i]);
       continue;
     }
     ret = (int)TEMP_FAILURE_RETRY(fstat(plugin_fd, &st));
     if(ret == -1){
       error(0, errno, "stat");
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     
@@ -909,7 +908,6 @@
 		direntries[i]->d_name);
       }
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     
@@ -917,7 +915,6 @@
     if(p == NULL){
       error(0, errno, "getplugin");
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     if(p->disabled){
@@ -926,7 +923,6 @@
 		direntries[i]->d_name);
       }
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     {
@@ -965,7 +961,6 @@
     if(ret == -1){
       error(0, errno, "pipe");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     if(pipefd[0] >= FD_SETSIZE){
@@ -974,7 +969,6 @@
       TEMP_FAILURE_RETRY(close(pipefd[0]));
       TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
 #ifndef O_CLOEXEC
@@ -985,7 +979,6 @@
       TEMP_FAILURE_RETRY(close(pipefd[0]));
       TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
@@ -994,7 +987,6 @@
       TEMP_FAILURE_RETRY(close(pipefd[0]));
       TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
 #endif	/* not O_CLOEXEC */
@@ -1005,7 +997,6 @@
     if(ret < 0){
       error(0, errno, "sigprocmask");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -1020,7 +1011,6 @@
       TEMP_FAILURE_RETRY(close(pipefd[0]));
       TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     if(pid == 0){
@@ -1065,10 +1055,8 @@
         error(0, errno, "sigprocmask");
       }
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-    free(direntries[i]);
     
     new_plugin->pid = pid;
     new_plugin->fd = pipefd[0];
@@ -1104,10 +1092,7 @@
     }
   }
   
-  free(direntries);
-  direntries = NULL;
   TEMP_FAILURE_RETRY(close(dir_fd));
-  dir_fd = -1;
   free_plugin(getplugin(NULL));
   
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -1307,8 +1292,6 @@
     free(custom_argv);
   }
   
-  free(direntries);
-  
   if(dir_fd != -1){
     TEMP_FAILURE_RETRY(close(dir_fd));
   }

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2014-07-15 23:52:00 +0000
+++ plugins.d/mandos-client.c	2014-06-13 22:13:56 +0000
@@ -234,21 +234,11 @@
 			  .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    free(new_server);
     return false;
   }
   ret = clock_gettime(CLOCK_MONOTONIC, &(new_server->last_seen));
   if(ret == -1){
     perror_plus("clock_gettime");
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    free((char *)(new_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
-    free(new_server);
     return false;
   }
   /* Special case of first server */
@@ -1076,7 +1066,6 @@
      timed out */
   
   if(quit_now){
-    avahi_s_service_resolver_free(r);
     return;
   }
   
@@ -1469,6 +1458,7 @@
   error_t ret_errno = 0;
   if(seteuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1485,6 +1475,7 @@
   }
   if(setuid(0) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1497,6 +1488,7 @@
   error_t ret_errno = 0;
   if(seteuid(uid) == -1){
     ret_errno = errno;
+    perror_plus("seteuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1509,6 +1501,7 @@
   error_t ret_errno = 0;
   if(setuid(uid) == -1){
     ret_errno = errno;
+    perror_plus("setuid");
   }
   errno = old_errno;
   return ret_errno;
@@ -1517,7 +1510,7 @@
 __attribute__((nonnull))
 void run_network_hooks(const char *mode, const char *interface,
 		       const float delay){
-  struct dirent **direntries = NULL;
+  struct dirent **direntries;
   if(hookdir_fd == -1){
     hookdir_fd = open(hookdir, O_RDONLY);
     if(hookdir_fd == -1){
@@ -1561,8 +1554,7 @@
     if(hook_pid == 0){
       /* Child */
       /* Raise privileges */
-      errno = raise_privileges_permanently();
-      if(errno != 0){
+      if(raise_privileges_permanently() != 0){
 	perror_plus("Failed to raise privileges");
 	_exit(EX_NOPERM);
       }
@@ -1653,7 +1645,6 @@
       int status;
       if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
 	perror_plus("waitpid");
-	free(direntry);
 	continue;
       }
       if(WIFEXITED(status)){
@@ -1661,19 +1652,16 @@
 	  fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
 		       " with status %d\n", direntry->d_name,
 		       WEXITSTATUS(status));
-	  free(direntry);
 	  continue;
 	}
       } else if(WIFSIGNALED(status)){
 	fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
 		     " signal %d\n", direntry->d_name,
 		     WTERMSIG(status));
-	free(direntry);
 	continue;
       } else {
 	fprintf_plus(stderr, "Warning: network hook \"%s\""
 		     " crashed\n", direntry->d_name);
-	free(direntry);
 	continue;
       }
     }
@@ -1681,9 +1669,7 @@
       fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
 		   direntry->d_name);
     }
-    free(direntry);
   }
-  free(direntries);
   if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
     perror_plus("close");
   } else {
@@ -1746,7 +1732,6 @@
     /* Raise privileges */
     ret_errno = raise_privileges();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     }
     
@@ -1856,7 +1841,6 @@
     /* Raise privileges */
     ret_errno = raise_privileges();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     }
     
@@ -2281,20 +2265,16 @@
 	if(ret_errno != 0){
 	  errno = ret_errno;
 	  perror_plus("argz_add");
-	  free(direntries[i]);
 	  continue;
 	}
 	if(debug){
 	  fprintf_plus(stderr, "Will use interface \"%s\"\n",
 		       direntries[i]->d_name);
 	}
-	free(direntries[i]);
       }
       free(direntries);
     } else {
-      if(ret == 0){
-	free(direntries);
-      }
+      free(direntries);
       fprintf_plus(stderr, "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
@@ -2564,14 +2544,6 @@
     mc.current_server->prev->next = NULL;
     while(mc.current_server != NULL){
       server *next = mc.current_server->next;
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-      free((char *)(mc.current_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
       free(mc.current_server);
       mc.current_server = next;
     }
@@ -2581,7 +2553,6 @@
   {
     ret_errno = raise_privileges();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to raise privileges");
     } else {
       
@@ -2610,7 +2581,6 @@
     
     ret_errno = lower_privileges_permanently();
     if(ret_errno != 0){
-      errno = ret_errno;
       perror_plus("Failed to lower privileges permanently");
     }
   }
@@ -2638,7 +2608,7 @@
       int numentries = scandir(tempdir, &direntries, notdotentries,
 			       alphasort);
 #endif	/* not __GLIBC__ */
-      if(numentries >= 0){
+      if(numentries > 0){
 	for(int i = 0; i < numentries; i++){
 	  ret = unlinkat(tempdir_fd, direntries[i]->d_name, 0);
 	  if(ret == -1){
@@ -2646,7 +2616,6 @@
 			 " \"%s\", 0): %s\n", tempdir,
 			 direntries[i]->d_name, strerror(errno));
 	  }
-	  free(direntries[i]);
 	}
 	
 	/* need to clean even if 0 because man page doesn't specify */

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2014-06-22 02:19:30 +0000
+++ plugins.d/mandos-client.xml	2014-03-06 02:26:04 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2014-06-22">
+<!ENTITY TIMESTAMP "2014-03-05">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -748,9 +748,8 @@
     <para>
       It will also help if the checker program on the server is
       configured to request something from the client which can not be
-      spoofed by someone else on the network, like SSH server key
-      fingerprints, and unlike unencrypted <acronym>ICMP</acronym>
-      echo (<quote>ping</quote>) replies.
+      spoofed by someone else on the network, unlike unencrypted
+      <acronym>ICMP</acronym> echo (<quote>ping</quote>) replies.
     </para>
     <para>
       <emphasis>Note</emphasis>: This makes it completely insecure to

